@echo off
cls
echo .
echo .     Welcome to LSI Logic Integrated SAS Flash Utility
echo .     This Utility will upgrade your LSI SAS HBA 
echo.
echo.
REM     ========================================================
REM         Start procedure to save old firmware and BIOS

echo            !!!             WARNING              !!!
echo            !!! LSI strongly recommends you save !!!
echo            !!!  the existing firmware and BIOS  !!!
echo            !!!    currently installed on your   !!!
echo            !!!        MegaRAID Controller       !!!
echo.
echo.
echo .     Your existing firmware will be saved as Firmware.fw
echo .     Your existing BIOS will be saved as     BIOS.rom
echo .     in the current directory
echo.

CHOICE /N                    press y or n     (yes or no)
REM Errollevel 1 = Save old firmware and BIOS
REM Errorlevel 2 = Don't save old firmware and BIOS
IF errorlevel 2 goto BoardType    
IF errorlevel 1 echo yes

:SaveOld
echo.
echo .     Saving old firmware and BIOS
echo.
sasflash -ufirmware Firmware.fw
sasflash -ubios BIOS.rom

:BoardType

REM             End procedure to save old firmware and BIOS
REM     ==========================================================

echo .
echo .    TO FLASH  8208ELP     press  1
echo .    TO FLASH  8204ELP     press  2
echo .    TO FLASH  8208XLP     press  3
echo .    TO FLASH  8204XLP     press  4
echo.
echo .    TO EXIT press 5
echo .

CHOICE /N /C:12345       press 1 to 5
IF errorlevel 5 goto exit
IF errorlevel 4 goto 8204XLP
IF errorlevel 3 goto 8208XLP
IF errorlevel 2 goto 8204ELP
IF errorlevel 1 goto 8208ELP
:8204XLP
set board=PCIX
goto skip1
:8208XLP
set board=PCIX
goto skip1
:8204ELP
set board=PCIE
goto skip1
:8208ELP
set board=PCIE
:skip1

sasflash -listall
echo.
echo.     Which Chip Version? (see output above)
echo .    For B0  press  1
echo .    For B1  press  2
echo .    For B2  press  3
echo .    For B3  press  4
echo.
echo .    To Exit press  5
echo .

CHOICE /N /C:12345       press 1 to 4 (or 5 to quit)
IF errorlevel 5 goto EXIT
IF errorlevel 4 goto chipb3
IF errorlevel 3 goto chipb2
IF errorlevel 2 goto chipb1
IF errorlevel 1 goto chipb0
:chipb3
set ver=B3
goto skip4
:chipb2
set ver=B2
goto skip4
:chipb1
set ver=B1
goto skip4
:chipb0
set ver=B0
:skip4

set name=%board%_%ver%.rom
echo.
echo.
echo .  You have slected %name% firmware with chip %ver%
echo.
echo    sasflash -f %name% 
echo    mptutil -b SWRBIOS.ROM
echo.
echo .    OK to Flash  press  F or f
echo.
echo .    TO EXIT press       q
echo .

CHOICE /N /C:fq       press F or q
IF errorlevel 2 GOTO EXIT
IF errorlevel 1 GOTO flash

:flash
sasflash -f %name%
mptutil -b SWRBIOS.ROM
echo .
echo .	Please reboot your system to complete the update
echo . 

:EXIT